function xij_min = min_dist(x)
    % [Function] 
    %
    % :returns: the mininum distance between a set of n points x.
    % :param x: nxm matrix, every row is a point in the set.
    % 
    sz = size(x);
    n = sz(1);
    m = sz(2);
    xij_min = inf;
    if m>1
        for i=2:n
            for j=1:i-1
                xij2 = sum((x(i,:)-x(j,:)).^2);
                xij_min = min(xij2,xij_min);
            end
        end            
        xij_min = sqrt(xij_min);
    else
        % x is usually complex 
        for i=2:n
            for j=1:i-1
                xij = abs(x(i)-x(j));
                xij_min = min(xij,xij_min);
            end
        end
    end
end
